message " compare/copy with extent".

def var bool as logical no-undo.
def var result as logical no-undo.

/* tt1 */
def temp-table tt1
field f1 as character extent 4
field f2 as character
field f3 as int
field f4 as int.

create tt1.
assign
tt1.f1[1] = "aa1"
tt1.f1[2] = "aa2"
tt1.f1[3] = "aa3"
tt1.f1[4] = "aa4"
tt1.f2 = "11"
tt1.f3 = 11
tt1.f4 = 11.

def buffer b1 for tt1.
def var hBuffer1 as handle.
hBuffer1 = buffer b1:handle.

/* tt2 */
def temp-table tt2
field f1 as character
field f2 as character
field f3 as int
field f4 as int.

create tt2.
assign tt2.f1 = "aa2"
tt2.f2 = "11"
tt2.f3 = 11
tt2.f4 = 11.

def buffer b2 for tt2.
def var hBuffer2 as handle.
hBuffer2 = buffer b2:handle.

/* tt3 */
def temp-table tt3
field f1 as int extent 4
field f2 as character
field f3 as int
field f4 as int.

create tt3.
assign
tt3.f1[1] = 1
tt3.f1[2] = 2
tt3.f1[3] = 3
tt3.f1[4] = 4
tt3.f2 = "11"
tt3.f3 = 11
tt3.f4 = 11.

def buffer b3 for tt3.
def var hBuffer3 as handle.
hBuffer3 = buffer b3:handle.

/* tt4 */
def temp-table tt4
field f1 as int extent 2
field f2 as character
field f3 as int
field f4 as int.

create tt4.
assign
tt4.f1[1] = 1
tt4.f1[2] = 2


tt4.f2 = "11"
tt4.f3 = 11
tt4.f4 = 11.

def buffer b4 for tt4.
def var hBuffer4 as handle.
hBuffer4 = buffer b4:handle.


hBuffer4:FIND-FIRST().
hBuffer3:FIND-FIRST().
hBuffer2:FIND-FIRST().
hBuffer1:FIND-FIRST().

message "============usual field compare/copy to field with extent".

bool=hBuffer1:buffer-compare(hBuffer2).
message "Result compare: " string(bool).


bool=hBuffer1:buffer-copy(hBuffer2).
message "Result copy: " string(bool).

message "============field compare/copy to field with the same extent but different type".


bool=hBuffer1:buffer-compare(hBuffer3).
message "Result compare: " string(bool).


bool=hBuffer1:buffer-copy(hBuffer3).
message "Result copy: " string(bool).



message "============field compare/copy to field with different extent".

bool=hBuffer4:buffer-compare(hBuffer3).
message "Result compare 4-3: " string(bool).


bool=hBuffer4:buffer-copy(hBuffer3).
message "Result copy 4 -3: " string(bool).

bool=hBuffer3:buffer-compare(hBuffer4).
message "Result compare 3-4: " string(bool).


bool=hBuffer3:buffer-copy(hBuffer4).
message "============Result copy 3 -4: " string(bool).


/*

compilation error in different

buffer-compare tt1 to tt2 CASE-SENSITIVE SAVE RESULT IN result.
message "CASE-SENSITIVE result: " result.

buffer-compare tt1 to tt2 SAVE RESULT IN result.
message "CASE-INSENSITIVE result: " result.
*/

